//Variablen der Entfernungsmess-Funktion, die wir mit dem QTI-Plotter modeliert haben.
  float a =1061.188;
  float b =12.50886;  
  float c =186.481;
  float maxEntfernungWert = 186.5; //Wenn der Input kleiner als dieser Wert ist, gibt es ein MAthematischen Error in dieser Funktion.
  int pinLED = 4;
  int pinSensorLED = A3; 
  int servoPin = 12;
//Start des programms durch die Nutzung der "Funktion" MODE; 

int mode = 0; // Funktion startet bei Null bzw. Anfang;

  #include <Servo.h> // Projetktbibliothek zum Servo, damit befehle klar sind.
  Servo antriebFlaschenschranke;// Der servo, an dem der Lichtsensor befästigt ist.
  int winkel = 150;  // Variablen initialisierung für den Winkel von dem Motor


void setup() {
  Serial.begin(9600); 
   
  antriebFlaschenschranke.attach(12,900, 2100); // Servomotor für Bierausgabe 
  antriebFlaschenschranke.write(winkel); 
}

void loop() {
 
 if(mode == 0){  // Mode 0 == Im Kreis fahren und Menschen suchen 
    
    float inputSensor = analogRead(A0); //Misst mit Sensor
    float entfernung = -1*log((inputSensor - c) / a)*b; //Rechnet inputSensor in Entfernung in cm um.
 
      if(inputSensor < maxEntfernungWert){
      Serial.println("mehr als 62,5cm");
      bewegungRoboter(3,120, 5,0, 6,120, 11,0, 1000); //Drehung mit Bewegungsfunktion
      }
 
      if(inputSensor > maxEntfernungWert && entfernung>15){ // wenn Mensch mehr als 15cm entfernt ist fährt der roboter geradeaus
      Serial.println("Distanz in cm:" +String (entfernung) + "\t" + "Messwert;"+ String(inputSensor));
      bewegungRoboter(3,0, 5,120, 6,120, 11,0, 500); //Gerade nach Vorne. (mit Funktion aus Funktionen) WIE KANN ICH dIE BENuTZEN
      }

      if( entfernung<15){
      mode = 1; //stehen bleiben, wenn Mensch weniger als 15cm entfernt ist == Person erreicht
      }

   }

 if(mode == 1){ //Überprüfung ob der vorherige Mode abgeschlossen wurde.
      Serial.println("Person erreicht!$");
      mode = 2; // Befehl zum Münzeinwurf
   }

 if( mode == 2) { // Mode Münzeinwurf
    pinMode(pinLED, OUTPUT);  
    digitalWrite(pinLED, HIGH); //LED einschalten
    
      if (analogRead(pinSensorLED) <= 500) {
      digitalWrite(4, LOW);
      Serial.println("jetzt");
      mode = 3; //Befehl zur Bier Ausgabe
      }
   }

if(mode == 3){ // Mode Bierausgabe
   antriebFlaschenschranke.attach(12,900, 2100);
    antriebFlaschenschranke.write(winkel);
    delay(1000);
    winkel = 0;
    antriebFlaschenschranke.write(winkel);
    delay(500);
    winkel = 150;
    antriebFlaschenschranke.write(winkel);
    
    mode = 4;
   
}
if(mode==4){ //Ausschalten Servo
     digitalWrite(12,LOW);
    
     mode=5;
    
}
if (mode==5){
  //fährt zurück
  delay(3000);
 
    bewegungRoboter(3,80, 5,0, 6,0, 11,80, 2000); // nach hinten gerade.

//drehung 
    bewegungRoboter(3,120, 5,0, 6,120, 11,0, 1200); // drehung nach rückwärts fahren.

mode = 0; //zum beginn des codes
}


}



void bewegungRoboter(int rechterMotorPin1, int pwmR1, int rechterMotorPin2,int pwmR2, int linkerMotorPin1, int pwmL1, int linkerMotorPin2, int pwmL2, int zeitBewegung){
    
  pinMode(rechterMotorPin1,OUTPUT);       // Rechts
    analogWrite(rechterMotorPin1,250);
    analogWrite(rechterMotorPin1,pwmR1);
    pinMode(rechterMotorPin2,OUTPUT);
    analogWrite(rechterMotorPin2, 250);
    analogWrite(rechterMotorPin2, pwmR2);

   

  pinMode(linkerMotorPin1,OUTPUT);       //Links
  analogWrite(linkerMotorPin1, 250);
 analogWrite(linkerMotorPin1, pwmL1);
  pinMode(linkerMotorPin2,OUTPUT);
  analogWrite(linkerMotorPin2, 250);
  analogWrite(linkerMotorPin2, pwmL2);
    
  delay(zeitBewegung);    

       pinMode(rechterMotorPin1,OUTPUT);       // Rechts
       analogWrite(rechterMotorPin1, 0);
       pinMode(rechterMotorPin2,OUTPUT);
       analogWrite(rechterMotorPin2, 0); //low

   

      pinMode(linkerMotorPin1,OUTPUT);       //Links
      analogWrite(linkerMotorPin1, 0); //low
      pinMode(linkerMotorPin2,OUTPUT);
      analogWrite(linkerMotorPin2, 0);
   
   delay(500); 
  }
